# $Id: proftpd.spec

%{?dist: %{expand: %%define %dist 1}}

%{?rh7:%define _without_acl 1}
%{?el2:%define _without_acl 1}
%{?el2:%define _without_postgresql 1}

Summary: Flexible, stable and highly-configurable FTP server
Name: proftpd
Version: 1.3.7c
Release: 1
License: GPL
Group: System Environment/Daemons
URL: http://www.proftpd.org/
Packager: Michael Stauber <mstauber@solarspeed.net>
Vendor: Project BlueOnyx
Source0: ftp://ftp.proftpd.org/distrib/source/proftpd-%{version}.tar.gz
Source1: proftpd.conf
Source2: proftpd.init
Source3: proftpd-xinetd
Source4: proftpd-bluequartz.logrotate
Source5: welcome.msg
Source6: proftpd.pam.shadow
Source7: proftpds-xinetd
Source9: proftpds.conf

BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root

BuildRequires: pam-devel, ncurses-devel, pkgconfig
BuildRequires: openssl-devel, krb5-devel
BuildRequires: openldap-devel, mysql-devel, zlib-devel
%{!?_without_acl:BuildRequires: libacl-devel}
%{!?_without_postgresql:BuildRequires: postgresql-devel}
Requires: pam >= 0.59
Requires(post): /sbin/chkconfig
Requires(preun): /sbin/service, /sbin/chkconfig
Requires(postun): /sbin/service
Provides: ftpserver

%description
ProFTPD is an enhanced FTP server with a focus toward simplicity, security,
and ease of configuration. It features a very Apache-like configuration
syntax, and a highly customizable server infrastructure, including support for
multiple 'virtual' FTP servers, anonymous FTP, and permission-based directory
visibility.

This package defaults to the xinetd behaviour of ProFTPD, but all the
needed scripts to have it run as standalone are included as well.

%package devel
Summary: Header files, libraries and development documentation for %{name}.
Group: Development/Libraries
Requires: %{name} = %{version}-%{release}

%description devel
This package contains the header files, static libraries and development
documentation for %{name}. If you like to develop programs using %{name},
you will need to install %{name}-devel.

%package ldap
Summary: Module to add LDAP support to the ProFTPD FTP server
Group: System Environment/Daemons
Requires: %{name} = %{version}-%{release}

%description ldap
Module to add LDAP support to the ProFTPD FTP server.

%package mysql
Summary: Module to add MySQL support to the ProFTPD FTP server
Group: System Environment/Daemons
Requires: %{name} = %{version}-%{release}

%description mysql
Module to add MySQL support to the ProFTPD FTP server.

%package postgresql
Summary: Module to add PostgreSQL support to the ProFTPD FTP server
Group: System Environment/Daemons
Requires: %{name} = %{version}-%{release}

%description postgresql
Module to add PostgreSQL support to the ProFTPD FTP server.

%prep
%setup

# Disable stripping in order to get useful debuginfo packages
%{__perl} -pi -e 's|"-s"|""|g' configure

%build
if pkg-config openssl; then
    export CFLAGS="%{optflags} $(pkg-config --cflags openssl)"
    export LDFLAGS="$LDFLAGS $(pkg-config --libs-only-L openssl)"
fi
%configure \
    --libexecdir="%{_libexecdir}/proftpd" \
    --localstatedir="%{_var}/run" \
    --enable-ctrls \
    --enable-dso \
    --enable-ipv6 \
%{!?_without_acl:--enable-facl} \
    --enable-openssl \
    --with-includes="%{_includedir}/mysql" \
    --with-libraries="%{_libdir}/mysql" \
    --with-modules="mod_readme:mod_auth_pam:mod_tls:mod_ban:mod_ctrls_admin:mod_geoip" \
    --with-shared="mod_ldap:mod_sql:mod_sql_mysql:%{!?_without_postgresql:mod_sql_postgres:}mod_quotatab:mod_quotatab_file:mod_quotatab_ldap:mod_quotatab_sql"
%{__make} %{?_smp_mflags}

#    --disable-ipv6 \
#    --enable-ipv6 \

%install
%{__rm} -rf %{buildroot}
%{__make} install DESTDIR="%{buildroot}" \
    rundir="%{_var}/run/proftpd" \
    INSTALL_USER=`id -un` \
    INSTALL_GROUP=`id -gn`
%{__install} -D -p -m 0640 %{SOURCE1} %{buildroot}%{_sysconfdir}/proftpd.conf
%{__install} -D -p -m 0640 %{SOURCE1} %{buildroot}%{_sysconfdir}/proftpd.conf.dist
%{__install} -D -p -m 0640 %{SOURCE9} %{buildroot}%{_sysconfdir}/proftpds.conf
%{__install} -D -p -m 0640 %{SOURCE9} %{buildroot}%{_sysconfdir}/proftpds.conf.dist
%{__install} -D -p -m 0755 %{SOURCE2} %{buildroot}%{_sysconfdir}/rc.d/init.d/proftpd
%{__install} -D -p -m 0640 %{SOURCE3} %{buildroot}%{_sysconfdir}/xinetd.d/proftpd
%{__install} -D -p -m 0640 %{SOURCE7} %{buildroot}%{_sysconfdir}/xinetd.d/proftpds
%{__install} -D -p -m 0644 %{SOURCE4} %{buildroot}%{_sysconfdir}/logrotate.d/proftpd
%{__install} -D -p -m 0644 %{SOURCE5} %{buildroot}/var/ftp/welcome.msg
%{__install} -D -p -m 0644 %{SOURCE6} %{buildroot}%{_sysconfdir}/pam.d/proftpd
#%{__install} -D -p -m 0755 %{SOURCE8} %{buildroot}/usr/sausalito/sbin/fixproftpd_conf_proftpd.pl
#%{__install} -D -p -m 0755 %{SOURCE10} %{buildroot}/usr/sausalito/sbin/fixproftpds_conf_proftpd.pl

%{__mkdir_p} %{buildroot}/var/ftp/uploads
%{__mkdir_p} %{buildroot}/var/ftp/pub
%{__mkdir_p} %{buildroot}/var/log/proftpd
touch %{buildroot}%{_sysconfdir}/ftpusers

%clean
%{__rm} -rf %{buildroot}

%post
if [ $1 -eq 1 ]; then
#    /sbin/chkconfig --add proftpd
    IFS=":"; cat /etc/passwd | \
    while { read username nu nu gid nu nu nu nu; }; do \
        if [ $gid -lt 100 -a "$username" != "ftp" ]; then
            echo $username >> %{_sysconfdir}/ftpusers
        fi
    done
fi

if [ -f /etc/pam.d/proftpd.rpmnew ]; then
	/bin/mv /etc/pam.d/proftpd.rpmnew /etc/pam.d/proftpd
fi

if [ "$(uname -m)" = "x86_64" ]; then
	/usr/bin/perl -pi -e 's/\/lib\//\/lib64\//' /etc/pam.d/proftpd
fi

# Replace the onboard proftpd.conf with proftpd.conf.dist:
/bin/cp /etc/proftpd.conf.dist /etc/proftpd.conf

# Replace the onboard proftpds.conf with proftpds.conf.dist:
/bin/cp /etc/proftpds.conf.dist /etc/proftpds.conf

if [ -f /etc/xinetd.d/proftpd.rpmnew ]; then
    /bin/mv /etc/xinetd.d/proftpd.rpmnew /etc/xinetd.d/proftpd
fi
if [ -f /etc/xinetd.d/proftpds.rpmnew ]; then
    /bin/mv /etc/xinetd.d/proftpds.rpmnew /etc/xinetd.d/proftpds
fi

# Sync XINETd Proftpd status back to XINETd files:
/usr/sausalito/constructor/base/ftp/syncFTP.pl

# Restart of xinetd:
/etc/init.d/xinetd restart &>/dev/null || :

%pre
# Pre-install cleanup:
if [ -f /etc/pam.d/proftpd.rpmnew ]; then
    /bin/rm -f /etc/pam.d/proftpd.rpmnew
fi

if [ -f /etc/proftpd.conf.rpmnew ]; then
    /bin/rm -f /etc/proftpd.conf.rpmnew
fi
if [ -f /etc/proftpds.conf.rpmnew ]; then
    /bin/rm -f /etc/proftpds.conf.rpmnew
fi

# Make backup of pre-existing /etc/proftpd.conf:
if [ -f /etc/proftpd.conf ]; then
    /bin/cp /etc/proftpd.conf /etc/proftpd.conf.pre-1.3.5e
fi

# Make backup of pre-existing /etc/proftpds.conf:
if [ -f /etc/proftpds.conf ]; then
    /bin/cp /etc/proftpds.conf /etc/proftpds.conf.pre-1.3.5e
fi

%preun
if [ $1 -eq 0 ]; then
    /sbin/service proftpd stop &>/dev/null || :
    /etc/init.d/xinetd stop &>/dev/null || :
    /sbin/chkconfig --del proftpd
    /sbin/service xinetd reload &>/dev/null || :
    if [ -d %{_var}/run/proftpd ]; then
        rm -rf %{_var}/run/proftpd/*
    fi
fi

%postun
if [ $1 -ge 1 ]; then
    /etc/init.d/xinetd restart &>/dev/null || :
fi

%files
%defattr(-, root, root, 0755)
%doc COPYING CREDITS ChangeLog NEWS README* doc/* sample-configurations/
%dir %{_localstatedir}/run/
%config %{_sysconfdir}/proftpd.conf.dist
#%config(noreplace) %{_sysconfdir}/proftpd.conf
%{_sysconfdir}/proftpd.conf
#%config(noreplace) %{_sysconfdir}/proftpds.conf
%{_sysconfdir}/proftpds.conf
%config %{_sysconfdir}/proftpds.conf.dist
%config(noreplace) %{_sysconfdir}/xinetd.d/proftpd
%config(noreplace) %{_sysconfdir}/xinetd.d/proftpds
%config %{_sysconfdir}/ftpusers
%config(noreplace) %{_sysconfdir}/pam.d/proftpd
%config(noreplace) %{_sysconfdir}/logrotate.d/proftpd
%{_sysconfdir}/rc.d/init.d/proftpd
%{_mandir}/man?/*
%{_bindir}/*
%dir %{_libexecdir}/proftpd/
%{_libexecdir}/proftpd/mod_quotatab.so
%{_libexecdir}/proftpd/mod_quotatab_file.so
%{_libexecdir}/proftpd/mod_sql.so
%{_sbindir}/*
%dir /var/ftp/
%dir /var/ftp/pub/
%config(noreplace) /var/ftp/welcome.msg
%config(noreplace) /usr/%{_lib}/pkgconfig/proftpd.pc

%defattr(0331, ftp, ftp, 0331)
%dir /var/ftp/uploads/

%defattr(0750, root, root, 0750)
%dir /var/log/proftpd/
%exclude %{_libexecdir}/proftpd/*.a
%exclude %{_libexecdir}/proftpd/*.la

%files devel
%defattr(-, root, root, 0755)
%{_includedir}/proftpd/

%files ldap
%defattr(-, root, root, 0755)
%dir %{_libexecdir}/proftpd/
%{_libexecdir}/proftpd/mod_ldap.so
%{_libexecdir}/proftpd/mod_quotatab_ldap.so

%files mysql
%defattr(-, root, root, 0755)
%dir %{_libexecdir}/proftpd/
%{_libexecdir}/proftpd/mod_sql_mysql.so
%{_libexecdir}/proftpd/mod_quotatab_sql.so

%if %{!?_without_postgresql:1}0
%files postgresql
%defattr(-, root, root, 0755)
%dir %{_libexecdir}/proftpd/
%{_libexecdir}/proftpd/mod_sql_postgres.so
%{_libexecdir}/proftpd/mod_quotatab_sql.so
%endif

%changelog

* Tue Nov 30 2021 Michael Stauber <mstauber@solarspeed.net> 1.3.7c-1
- Update to 1.3.7c.

* Tue Jul 23 2019 Michael Stauber <mstauber@solarspeed.net> 1.3.7-RC1
- Latest SVN checkout from today to fix CVE-2019-12815 in mod_copy
- Removed deprecated IdentLookups from proftpd.conf

* Tue Nov 14 2017 Michael Stauber <mstauber@solarspeed.net> 1.3.5e-1BX7
- Simplified conf for usage without VirtualHost containers.
- Update to 1.3.5e.

* Fri May 01 2015 Michael Stauber <mstauber@solarspeed.net> 1.3.5-1BX6
- Hard coded flag IPv4 in Xinetd config for ProFTPd and ProFTPds.
- ProFTPd behaves totally unpredictable if IPv6 is enabled.

* Sun Nov 02 2014 Michael Stauber <mstauber@solarspeed.net> 1.3.5-1BX5
- Enabled IPv6 again. Some BlueOnyx have it active for one reason or 
  another. In which case a 'telnet localhost 21' goes to '::1' instead of
  '127.0.0.1'. An IP that our pure IPv4 ProFTPd doesn't listen on. Hence
  Active Monitor then says 'It's dead, Jim', when in fact it's running.

* Sat Nov 01 2014 Michael Stauber <mstauber@solarspeed.net> 1.3.5-1BX4
- Rebuilt with the following extra modules:
- mod_ctrls_admin
- Added built in GeoIP support
- Added -N to xinetd.d files and removed a redundant line.
- Added Control Module config to proftpd.conf and proftpds.conf
- Cleaned up ProFTPd config files.

* Thu Oct 30 2014 Michael Stauber <mstauber@solarspeed.net> 1.3.5-1BX3
- Added support for separate proftpds.conf for SSL/TLS
- Removed all TLS/SSL provisions from proftpd.conf

* Thu Oct 30 2014 Michael Stauber <mstauber@solarspeed.net> 1.3.5-1BX2
- Explicitly disabled IPv6 via ./configure --disable-ipv6 ...

* Wed Oct 29 2014 Michael Stauber <mstauber@solarspeed.net> 1.3.5-1BX1
- Rebuilt with 1.3.5
- Modified proftpd.conf to turn off SSLv3.

* Sat Jan 25 2014 Michael Stauber <mstauber@solarspeed.net> 1.3.4d-1BX1
- Rebuilt with 1.3.4d
- Modified proftpd.conf for better sftp/ftps support.

* Mon May 14 2012 Michael Stauber <mstauber@solarspeed.net> 1.3.4a-1BX2
- Rebuilt

* Sun May 06 2012 Michael Stauber <mstauber@solarspeed.net> 1.3.4a-1BX1
- Updated to 1.3.4a for security reasons

* Thu Nov 03 2011 Michael Stauber <mstauber@solarspeed.net> 1.3.3e-1BX3
- Added provisions for arch specific /etc/pam.d/proftpd

* Tue Apr 19 2011 Michael Stauber <mstauber@solarspeed.net> 1.3.3e-1BX2
- Update to 1.3.3e. Maintenance release in preparation for the 5.6 ISO to fix
  buggered pre- and post-install scripts that only worked fine during upgrades.

* Mon Nov 08 2010 Michael Stauber <mstauber@solarspeed.net> 1.3.3c-1BX1
- Update to 1.3.3c for security reasons

* Fri Aug 07 2009 Michael Stauber <mstauber@solarspeed.net> 1.3.2a-1BX2
- Fixed snafu in /etc/pam.d/proftpd

* Thu Aug 06 2009 Michael Stauber <mstauber@solarspeed.net> 1.3.2a-1BX1
- Sources upgraded to 1.3.2a
- Added mod_ban module and rudimentary mod_ban config into proftpd.conf
- Replaced proftpd.pam with proftpd.pam.shadow
- Made sure that the stock proftpd.conf is also installed as proftpd.conf.dist
- Added mechanisms to pre- and post install scripts to make sure that new proftpd.conf and PAM config are installed.

* Tue Jun 02 2008 Michael Stauber <mstauber@solarspeed.net> 1.3.1-1BQ1
- New build from latest sources for 5106
- TLS support added with usage of the Dovecot SSL cert

* Sun Jun 25 2006 Hisao SHIBUYA <shibuya@alpha.or.jp> 1.2.10-1BQ4
- modify proftpd.conf to add IdentLookups.

* Sat Jun 10 2006 Hisao SHIBUYA <shibuya@alpha.or.jp> 1.2.10-1BQ3
- modify xinetd config to remove USERID for slow connection.

* Thu Feb 23 2006 Hisao SHIBUYA <shibuya@alpha.or.jp> 1.2.10-1BQ2
- fixed logrotate conf by Brian

* Mon Dec 26 2005 Gregory Boehnlein <damin@nacs.net> 1.2.10-1BQ1
- Updated to proftpd 1.2.10
- Removed README.mod_sql from spec file - no longer in archive

* Thu Dec 09 2004 Hisao SHIBUYA <shibuya@alpha.or.jp> 1.2.9-8BQ2
- fixed logrotate conf

* Thu Sep 16 2004 Hisao SHIBUYA <shibuya@alpha.or.jp> 1.2.9-8BQ1
- build for Blue Quartz

* Tue Jun 22 2004 Matthias Saou <http://freshrpms.net/> 1.2.9-8
- Added ncurses-devel build requires to fix the ftptop utility.

* Fri Feb 26 2004 Magnus-swe <Magnus-swe@telia.com> 1.2.9-7
- Fixed the scoreboard and pidfile issues.

* Fri Jan  9 2004 Matthias Saou <http://freshrpms.net/> 1.2.9-6
- Pass /var/run/proftpd as localstatedir to configure to fix pid and
  scoreboard file problems.

* Wed Dec 10 2003 Matthias Saou <http://freshrpms.net/> 1.2.9-4
- Fixed the MySQL include path, thanks to Jim Richardson.
- Renamed the postgres conditional build to postgresql.

* Tue Nov 11 2003 Matthias Saou <http://freshrpms.net/> 1.2.9-3
- Renamed the xinetd service to xproftpd to avoid conflict.
- Only HUP the standalone proftpd through logrotate if it's running.

* Fri Nov  7 2003 Matthias Saou <http://freshrpms.net/> 1.2.9-2
- Rebuild for Fedora Core 1.
- Modified the init script to make it i18n aware.

* Fri Oct 31 2003 Matthias Saou <http://freshrpms.net/> 1.2.9-1
- Update to 1.2.9.

* Wed Sep 24 2003 Matthias Saou <http://freshrpms.net/>
- Update to 1.2.8p to fix secutiry vulnerability.
- Fix the TLS build option at last, enable it by default.

* Mon Aug  4 2003 Matthias Saou <http://freshrpms.net/>
- Minor fixes in included README files.

* Mon Mar 31 2003 Matthias Saou <http://freshrpms.net/>
- Rebuilt for Red Hat Linux 9.

* Thu Mar 13 2003 Matthias Saou <http://freshrpms.net/>
- Update to 1.2.8.
- Remove the renamed linuxprivs module.
- Added TLS module build option.

* Fri Dec 13 2002 Matthias Saou <http://freshrpms.net/>
- Fix change for ScoreboardFile in the default conf, thanks to Sven Hoexter.

* Mon Dec  9 2002 Matthias Saou <http://freshrpms.net/>
- Update to 1.2.7.

* Thu Sep 26 2002 Matthias Saou <http://freshrpms.net/>
- Rebuilt for Red Hat Linux 8.0.

* Tue Sep 17 2002 Matthias Saou <http://freshrpms.net/>
- Update to 1.2.6.
- Fixed typo in the config for "AllowForeignAddress" thanks to Michel Kraus.
- Removed obsolete user install patch.
- Added "modular" ldap, mysql and postgresql support.

* Mon Jun 10 2002 Matthias Saou <http://freshrpms.net/>
- Update to 1.2.5.
- Changed the welcome.msg to config so that it doesn't get replaced.

* Fri May  3 2002 Matthias Saou <http://freshrpms.net/>
- Rebuilt against Red Hat Linux 7.3.
- Added the %%{?_smp_mflags} expansion.

* Tue Oct 23 2001 Matthias Saou <http://freshrpms.net/>
- Changed the default config file : Where the pid file is stored, addedd
  an upload authorization in anon server, and separate anon logfiles.
- Updated welcome.msg to something nicer.

* Fri Oct 19 2001 Matthias Saou <http://freshrpms.net/>
- Update to 1.2.4, since 1.2.3 had a nasty umask bug.

* Sat Aug 18 2001 Matthias Saou <http://freshrpms.net/>
- Update to 1.2.2 final.
- Changed the default config file a lot.

* Wed Apr 25 2001 Matthias Saou <http://freshrpms.net/>
- Update to 1.2.2rc2.

* Mon Apr  1 2001 Matthias Saou <http://freshrpms.net/>
- Update to 1.2.2rc1.

* Tue Mar 20 2001 Matthias Saou <http://freshrpms.net/>
- Added a DenyFilter to prevent a recently discovered DOS attack.
  This is only useful for fresh installs since the config file is not
  overwritten.

* Fri Mar  2 2001 Matthias Saou <http://freshrpms.net/>
- Upgraded to 1.2.1.
- New init script (added condrestart).

* Tue Feb 27 2001 Matthias Saou <http://freshrpms.net/>
- Upgraded to 1.2.0 final.

* Tue Feb  6 2001 Matthias Saou <http://freshrpms.net/>
- Upgraded to 1.2.0rc3 (at last a new version!)
- Modified the spec file to support transparent upgrades

* Wed Nov  8 2000 Matthias Saou <http://freshrpms.net/>
- Upgraded to the latest CVS to fix the "no PORT command" bug
- Fixed the ftpuser creation script
- Modified the default config file to easily change to an anonymous
  server

* Sun Oct 15 2000 Matthias Saou <http://freshrpms.net/>
  [proftpd-1.2.0rc2-2]
- Updated the spec file and build process for RedHat 7.0
- Added xinetd support
- Added logrotate.d support

* Fri Jul 28 2000 Matthias Saou <http://freshrpms.net/>
  [proftpd-1.2.0rc2-1]
- Upgraded to 1.2.0rc2

- Upgraded to 1.2.0rc1
* Sat Jul 22 2000 Matthias Saou <http://freshrpms.net/>
  [proftpd-1.2.0rc1-1]
- Upgraded to 1.2.0rc1
- Re-did the whole spec file (it's hopefully cleaner now)
- Made a patch to be able to build the RPM as an other user than root
- Added default pam support (but without /etc/shells check)
- Rewrote the rc.d script (mostly exit levels and ftpshut stuff)
- Modified the default configuration file to not display a version number
- Changed the package to standalone in one single RPM easily changeable
  to inetd (for not-so-newbie users)
- Fixed the ftpusers generating shell script (missing "nu"s for me...)
- Removed mod_ratio (usually used with databases modules anyway)
- Removed the prefix (relocations a rarely used on non-X packages)
- Gzipped the man pages

* Thu Oct 03 1999 O.Elliyasa <osman@Cable.EU.org>
- Multi package creation.
  Created core, standalone, inetd (&doc) package creations.
  Added startup script for init.d
  Need to make the "standalone & inetd" packages being created as "noarch"
- Added URL.
- Added prefix to make the package relocatable.

* Wed Sep 08 1999 O.Elliyasa <osman@Cable.EU.org>
- Corrected inetd.conf line addition/change logic.

* Sat Jul 24 1999 MacGyver <macgyver@tos.net>
- Initial import of spec.
